/*
IXPostingCursor.h
Copyright 1991,NeXT Computer,Inc.
*/

#import	"IXBTreeCursor.h"

// This class implements an inversion cursor.  It manages the values, as well 
// as the keys, stored in the BTree.  The values are lists of weighted handles.  
// A handle is an arbitrary identifier.  The weight is an arbitrary unsigned 
// integer value that could represent term weighting for text retrieval, or a 
// hint for fast secondary key access.

// The handles for a given key are represented internally as sixteen bit 
// quantities until the first handle is seen that requires more than sixteen 
// bits; at that point, all of the handles for the key are represented 
// internally as thirty two bit quantities.  The weights for a given key are 
// omitted until a non zero weight is seen; at that point, all of the handles 
// are weighted using sixteen or thirty two bits, accordingly.  When the length 
// of the list surpasses four blocks, it is represented internally as a BTree.

#ifdef	NX_COMPILER_RELEASE_3_0
@interface IXPostingCursor: IXBTreeCursor <IXPostingExchange, IXPostingOperations>
#else	NX_COMPILER_RELEASE_3_0
@interface IXPostingCursor: IXBTreeCursor
#endif	NX_COMPILER_RELEASE_3_0
{
    IXPosting			*_thisPosting;
    struct PostingArray		*_cursorValue;
    unsigned			_cursorLength;
    IXBTreeCursor		*_valueCursor;
}

@end
